//
#include <Wire.h>
// Definir Pines
int PinReset = 4;  //WTV020 - Reset
int PinClock = 5;  //WTV020 - Clock
int PinData  = 3;  //WTV020 - Data
int PinBusy  = 2;  //WTV020 - Busy - Not used
int PinRed   = 10;  //RGB Led Red
int PinGreen = 11;  //RGB Led Green
int PinBlue  =  9;  //RGB Led Blue
//Variables
int Bytes[5];           //Array for I2c received Data
int Volumen = 0xFFF7;   //Max volume WTV020
int Dato = 0x0000;      //Store Data to WTV020 send void
int Flag = 0;           //Flag control received data
// Start
void setup() {
    //Configure Wire
    Wire.begin(0x09);             // adress 0x09 acting as BlinkM
    Wire.onReceive(receiveEvent); // Receive as Interruption
    //
    // Configure pins
    pinMode (PinReset, OUTPUT);
    pinMode (PinClock, OUTPUT); 
    pinMode (PinData,  OUTPUT);
    pinMode (PinBusy,  INPUT);
    //
    pinMode (PinRed,   OUTPUT);
    pinMode (PinGreen, OUTPUT);
    pinMode (PinBlue,  OUTPUT);
    //Init pins
    digitalWrite (PinReset, HIGH);
    digitalWrite (PinClock, HIGH);
    digitalWrite (PinData,  HIGH);
    //Off RGB Led (Black)
    analogWrite (PinRed,0);
    analogWrite (PinGreen,0);
    analogWrite (PinBlue,0);
    //Reset WTV020
    Reset_WTV();
    //Max volume
    Dato = Volumen;
    Enviar();
}
//Main loop
void loop()
{
  if (Flag == 1)
  {
    //If "on" header received from M150 ...
    if (Bytes[0] == 111 && Bytes[1] == 110)
  {
    //If R255 was received it's a sound orde. Send Uxxx byte
    if (Bytes[2] == 255)
      {
        Dato = Bytes[3];
        Enviar();
      }
      // If R byte is not 255, then it's an RGB order
      else {
            analogWrite (PinRed,Bytes[2]);
            analogWrite (PinGreen,Bytes[3]);
            analogWrite (PinBlue,Bytes[4]);
      }
   Flag = 0;   
}
}
}
//I2C Receive Interruption
void receiveEvent(int howMany)
{
  //Store received data in Bytes[] array
  for (int i = 0; i < howMany; i++)
    {
    Bytes[i] = Wire.read ();
  }
  Flag = 1;
}
//Reset WTV020
void Reset_WTV(){
  digitalWrite(PinReset, LOW);
  delay(5);
  digitalWrite(PinReset, HIGH);
  delay(300);
}
//Send order to WTV020
void Enviar(){
  Serial.print(Dato,HEX);
        Serial.println();
  //Reset
  digitalWrite(PinReset, LOW);
  delay(5);
  digitalWrite(PinReset, HIGH);
  delay(300);
  //
  digitalWrite(PinClock, LOW);
  delay(2);
    for (int i=15; i>=0; i--){
        delayMicroseconds(50);
        if((Dato>>i)&0x0001 >0)
         {digitalWrite(PinData, HIGH);}         
          else
         {digitalWrite(PinData, LOW);}
 
       delayMicroseconds(50);
       digitalWrite(PinClock, HIGH);            
       delayMicroseconds(50);
        
        if (i > 0)
          {digitalWrite(PinData, LOW);}
        else
          {digitalWrite(PinData, HIGH);}
        
        delayMicroseconds(50);
        
        if (i > 0)
          {digitalWrite(PinClock, LOW);}
        else
          {digitalWrite(PinClock, HIGH);}
    }
  delay(20);
}
